/*
 =========================================================================================================
 C. Voglis, Department of Computer Science,
 Univeristy of Ioannina, Greece

 File: 				SOURCE_UPO_DE.h
 Usage: 			External definitions used for the main method
 Last Modified: 	21/08/2013
 =========================================================================================================
 */

#ifndef _SOURCE_UPSO_DE_H_
#define _SOURCE_UPSO_DE_H_

extern double norm_diff(int dim, double X[], double Y[], int WhichNorm);
extern void Objective_F(double X[], int N, double *F);
extern double normal_distrib();
extern void copy_vector(int size, double X[], double Y[]);
extern int StopCriterion(PROBLEM_par prob, RUN_STATS *stats);
extern void local_optimization(double *inout_x, int n,
		double *out_val, double *grms, double *xll, double *xrl, int *local, long *fc, long *gc);
extern void randperm(int dim, int V[]);
extern double norm_diff(int dim, double X[], double Y[], int WhichNorm);
extern double mat_stdev(int N, int M, double Y[]);
extern double mat_max(int N, int M, double Y[]);
extern double mat_mean(int N, int M, double Y[]);
extern double euclidean_std(int N, int M, double Y[]);
extern void print_swarm(double swarm[], int n, int m);

extern int noprint;


#endif
