#ifndef _SOURCE_LONG_OPTIONS_H_
#define _SOURCE_LONG_OPTIONS_H_

/*
 *
  Structure long_options holds the correspondace between
  the short (-a) and the long (--algorithm) flags of the
  command line.
 *
 */
static struct option long_options[] =
{
               /* These options set a flag. */
               {"help", no_argument,   0, 'h'},
               {"file-output",  no_argument,  0, 'p'},
               {"print-solution",    no_argument, 0, 'x'},
               /* These options don't set a flag.
                  We distinguish them by their indices. */
               {"mds-params",  required_argument,     0, 'T'},
               {"bfgs-params",  required_argument,     0, 'B'},
               {"algorithm",  required_argument,     0, 'a'},
               {"objective",  required_argument,     0, 'o'},
               {"local-seach",  required_argument,     0, 'm'},
               {"dimension",  required_argument, 0, 'd'},
               {"swarm-size",  required_argument, 0, 's'},
               {"max-fun-evals",    required_argument, 0, 'f'},
               {"max-grad-evals",    required_argument, 0, 'g'},
               {"max-iter",    required_argument, 0, 'i'},
               {"target-value",    required_argument, 0, 't'},
               {"num-experiments",    required_argument, 0, 'e'},
               {"radius",    required_argument, 0, 'r'},
               {"unification-factor",    required_argument, 0, 'u'},
               {"max-fun-evals",    required_argument, 0, 'f'},
               {"pso-params",    required_argument, 0, 'b'},
               {"seed",    required_argument, 0, 'n'},
               {"use-mutation",    required_argument, 0, 'U'},
               {"mutation-mean",    required_argument, 0, 'M'},
               {"mutation-std",    required_argument, 0, 'S'},
               {"F-param",    required_argument, 0, 'F'},
               {"CR-param",    required_argument, 0, 'C'},
               {"de-strategy",    required_argument, 0, 'v'},
               {"out-file-prefix",    required_argument, 0, 'O'},
               {"memetic",    required_argument, 0, 'l'},
               {"velocity-scaling",    required_argument, 0, 'c'},
               {"prob-local-search",    required_argument, 0, 'P'},
               {"dump-iterations",    required_argument, 0, 'D'},
               {"EPS",    required_argument, 0, 'E'},
               {"XEPS",    required_argument, 0, 'X'},
               {"FEPS",    required_argument, 0, 'Y'},
               {"GEPS",    required_argument, 0, 'G'},
               {"infile",    required_argument, 0, 'y'},
               {"outfile",    required_argument, 0, 'z'},
               {"dump-to-file",    required_argument, 0, 'W'},
               {"restore-from-file",    required_argument, 0, 'R'},
               {0, 0, 0, 0}
};

#endif
