/*
 =========================================================================================================
 C. Voglis, Department of Computer Science,
 Univeristy of Ioannina, Greece

 File: 				objective.h
 Usage: 			Header file to be included in objective function implementations.
				    Defines the FEVALCOUNT for counting the tasks
 Last Modified: 	21/08/2013
 =========================================================================================================
 */

#ifndef OBJECTIVE_H_
#define OBJECTIVE_H_

#if defined(_OPENMP)
#include <omp.h>
#else
#define	omp_get_thread_num()	0
#endif

extern unsigned long fcntr;
extern unsigned long fcntr2[MAXOMP];

#define FEVALCOUNT  _Pragma("omp atomic")  \
                  fcntr++;            \
                  _Pragma("omp atomic") \
                  fcntr2[omp_get_thread_num()]++;

struct{
	int ipro;
} funcid_;



#endif /* OBJECTIVE_H_ */
