#include <stdio.h>
#include <stdlib.h>
#if defined(_OPENMP)
#include <omp.h>
#endif
#include "mempsode.h"

int main(int argc, char **argv)
{
	int i;
	double val, point[1000];
	int fcnt[64];
	int int_thread_env;
	FILE *fp;
	

	init_mempsode();
	set_mempsode_iparam("algorithm", 1);
	set_mempsode_iparam("dimension", 9);
	set_mempsode_iparam("swarm-size", 100);
	set_mempsode_iparam("max-fun-evals", 50000);
	set_mempsode_iparam("dump-iterations", 0);
	set_mempsode_iparam("memetic", 0);
	set_mempsode_iparam("seed", 1);
	set_mempsode_iparam("method", 0);
	set_mempsode_iparam("omp-stats", 1);
	set_mempsode_cparam("mds-params", "theta=0.1 mu=0.1 delta=0.1");
 

	mempsode();

	get_mempsode_min("minval", &val);
	get_mempsode_min("minx", point);
	get_mempsode_iparam("omp-fevals", fcnt);
    	printf("Val -->%f \n",  val);
	for (i=0; i<prob.dim; i++)
		printf("X(%i)=%f\n", i, point[i]);

#if defined(_OPENMP)
	#pragma omp parallel
	#pragma omp single
	int_thread_env = omp_get_num_threads();
#else
	int_thread_env = 1;
#endif
	for (i=0; i<int_thread_env; i++)
		printf("%i -> %i \n", i, fcnt[i]);


	fp = fopen("plot.in", "w");
	if (fp!=NULL)
	{
		fprintf(fp, "set term post \n");
		fprintf(fp, "set output 'fit.eps' \n");
		fprintf(fp, "plot %.2f*exp(-(x-%.2f)**2/%.2f)+ %.2f*exp(-(x-%.2f)**2/%.2f)+%.2f*exp(-(x-%.2f)**2/%.2f), 'data.txt' with points \n", 
		             point[0], point[1], point[2], point[3], point[4], point[5], point[6], point[7], point[8]);
	}
	fclose(fp);

	return 0;
}
