#include "util.h"
#include <stdio.h>
#include <unistd.h>

char SOCK_PATH[256];

int counter = 0;
double start, end;
int idim;

extern void enertinker_();
extern void granalize_();
void process_a_received_descriptor(double *datain, int sock)
{
	double *dataout, *dataout_g; 
	int sizeout = 1*sizeof(double);
	int sizeout_g = idim*sizeof(double);

	dataout = (double *) malloc(1*sizeof(double));
	dataout_g = (double *) malloc(idim*sizeof(double));
#if DBG
	printf("datain[idim] = %lf\n", datain[idim]);
#endif

	if (datain[idim] == 0.0)
	{
		enertinker_(datain, &dataout[0], &idim); 
		send_all(sock, dataout, sizeout);
	}
	else
	{
		granalize_( &idim, datain, dataout_g );
		send_all(sock, dataout_g, sizeout_g);
	}
	//dataout[0] = datain[0]*datain[0];

/*	if (counter == ITERS) {
		end = nth_gettime();
		printf("SERVER: Elapsed time for %d iters = %.3lf us (%.3lf us/iter)\n", ITERS, 1e6*(end-start), 1e6*(end-start)/counter);
		exit(0);
	}
	*/
}


void server(void *arg)
{
	int newfd;        // newly accept()ed socket descriptor
	int ListenerSocket;
	int bytes;
	unsigned int addr_len;
	struct sockaddr_un serverAddress;
	struct sockaddr_un clientAddress;
	int servlen;

	double *datain;
	int sizein = (idim+1)*sizeof(double);

	datain = (double *) malloc(sizein);
	
	// get the listener
	if ((ListenerSocket = socket(AF_UNIX, SOCK_STREAM, 0)) == -1) {
		perror("socket");
		exit(1);
	}
	unlink(SOCK_PATH);

	// bind
	bzero(&serverAddress, sizeof(serverAddress));
	serverAddress.sun_family = AF_UNIX;
	strcpy(serverAddress.sun_path, SOCK_PATH);
	servlen = sizeof(serverAddress.sun_family) + strlen(serverAddress.sun_path);
	
	if (bind(ListenerSocket, (struct sockaddr *)&serverAddress, servlen) < 0) {
		perror("bind");
		exit(1);
	}
	
	// listen (only 1)
	if (listen(ListenerSocket, 1) == -1) {
		perror("listen");
		exit(1);
	}
	

/*	Increase priority of the Listener thread ? */

	// handle new connections
	while (1){
	addr_len = sizeof(clientAddress);
	if ((newfd = accept(ListenerSocket, (struct sockaddr *)&clientAddress, &addr_len)) == -1) { 
		perror("accept");
	}
	else {
#if DBG
		printf("selectserver: new connection from on socket %d", newfd);
#endif
	}

	
	while (1) {
		// handle data from a client
		if ((bytes = recv_all(newfd, datain, sizein)) <= 0) {	// got error or connection closed by client
			if (bytes == 0) {	// connection closed
#if DBG
				printf("selectserver: socket %d hung up\n", newfd);
#endif
			} else {
				perror("(1) recv");
			}
			close(newfd); // bye!
			break;
		}
		else { /* (bytes == nbyte)*/ 
			process_a_received_descriptor(datain, newfd);
		}
	}
	}
	close(ListenerSocket);
	return;
}

extern void inittinker_();
extern int probdim_();

int main(int argc, char *argv[])
{
	if (argc != 3) {
		printf("Usage: %s <sock_path> <id>\n", argv[0]);
		exit(1);
	}
	
printf("before init \n");
	inittinker_();	
printf("tinker init \n");
	idim = probdim_();
	printf("problem dim = %i \n", idim);
	sprintf(SOCK_PATH, "%s%s\n", argv[1], argv[2]);
	printf("SOCK_PATH=%s\n", SOCK_PATH);

	printf("starting...\n");
	server(NULL);
	printf("exiting\n");

	return 0;
}






