	subroutine inittinker
	implicit none
	integer maxn
	parameter ( maxn = 1000 )
	double precision en, calendar, t1, t2, t3

	include 'sizes.i'
	include 'files.i'
	include 'inform.i'
	include 'iounit.i'
	include 'math.i'
	include 'omega.i'
	include 'zcoord.i'
	include 'usage.i'
	include 'atoms.i'
C
	integer mnat, i, ixyz, nunit
	double precision energy, fl
C
	t1=calendar()
	call initial
	call getint
	call mechanic
	t2=calendar()
cc	write (*,*) t2-t1
	nomega = 0
	mnat = n
	do i=4,mnat
		if (iz(4,i).eq.0) then
			nomega = nomega+1
			iomega(1,nomega) = iz(1,i)
			iomega(2,nomega) = iz(2,i)
			dihed(nomega) = ztors(i)/radian
			zline(nomega) = i
		end if
	end do
	do i=1,mnat
		use(i) = .true.
	end do
c
	write (*,*) 'NOMEGA=',nomega
	if (nomega.gt.maxn) stop 'ERR'
	end

	subroutine enertinker(xmer, val, nn)
	implicit none
	integer nn, i
	double precision xmer(nn), val, energy, en

	include 'sizes.i'
	include 'files.i'
	include 'inform.i'
	include 'iounit.i'
	include 'math.i'
	include 'omega.i'
	include 'zcoord.i'
	include 'usage.i'
	include 'atoms.i'

C
	do i = 1, nomega
		ztors(zline(i)) = xmer(i)
	end do
C
	call makexyz
	val = energy()
C	write (*,*) 'ENERGY=',val
	end

	integer function probdim()
        include 'sizes.i'
        include 'files.i'
        include 'inform.i'
        include 'iounit.i'
        include 'math.i'
        include 'omega.i'
        include 'zcoord.i'
        include 'usage.i'
        include 'atoms.i'
		probdim = nomega
	end 
C
	subroutine granalize( nmer, xmer, gmer )
	implicit none
	integer nmer
	double precision xmer(nmer), gmer(nmer)
	include 'sizes.i'
	include 'omega.i'
	include 'zcoord.i'
	include 'atoms.i'
C
	integer i
	double precision energy, radian
C
	do i=1,nomega
		ztors(zline(i)) = xmer(i)
	end do
	call makexyz
	call gradrot(energy,gmer)
	radian = 57.29577951308232088d0
	do i=1,nomega
		gmer(i) = gmer(i)/radian
	end do
	end
c
      double precision function calendar ()
      implicit none
      integer year,month
      integer day,hour
      integer minute,second
c
c
c     use the standard "date_and_time" intrinsic function
c
      integer values(8)
      character*5 zone
      character*8 date
      character*10 time
      call date_and_time (date,time,zone,values)
      year = values(1)
      month = values(2)
      day = values(3)
      hour = values(5)
      minute = values(6)
      second = values(7)
	calendar=second+values(8)/1000.0
c
c     use the obsolete "itime" and "idate" intrinsic functions
c
c     integer hms(3)
c     call itime (hms)
c     hour = hms(1)
c     minute = hms(2)
c     second = hms(3)
c     call idate (month,day,year)
      return
      end
